; WIN87EM.ASM
; Author: Pat Ritchey,  CIS:[70007,4660]
;
; The __FPMATH function exported by WIN87EM.DLL uses CPU registers to
; pass parameters.  This requires an assembler module since the standard
; BP entry code will trash the AX register.  __FPMATH simply pushes the
; CPU registers that contains parameter, establishes DS addressability
; and calls the BP7 procedure FPMATH.

DATA SEGMENT
DATA ENDS

CODE SEGMENT
;
     EXTRN FPMATH:FAR
     PUBLIC __FPMATH
;
__FPMATH PROC FAR
   push ds
   push bx
   push dx
   push ax
   mov  ax,SEG DATA
   mov  ds,ax
   call FPMATH
   pop  ds
   ret
__FPMATH ENDP

CODE ENDS
     END
